function [K,C,A,fTestSample] = CentralizeKernel(K,RSamples)
    C = [];
    A = [];
    if(~iscell(K))
        K      = 0.5*(K+K');
        N      = size(K,1);
        vMeanK = K * ones(N,1); % will be true mean - X two rows later
        dMeanK = sum(vMeanK)/(N*N);
        vMeanK = vMeanK/N - dMeanK;               
        %fTestSample = @(Kx)Kx'- vMeanK -  mean(Kx);        
        fTestSample = @(Kx)bsxfun(@minus,Kx',bsxfun(@plus,vMeanK,mean(Kx,2)'));
        % - with kernel vector as input - see 'Eigenproblems in Pattern Recognition'
        K = fTestSample(K);        
        if(0) % based on eigenvalues
            [e,v]  = eig(K);
            MeanE  = mean(e);
            K      = bsxfun(@minus,e,MeanE) * v * bsxfun(@minus,e,MeanE)';
            % - with eigen vector as input
            ECentered = bsxfun(@minus,e,MeanE);
            fTestSampleHelper = @(ExC)ECentered * v * ExC';
            fTestSample       = @(Ex)fTestSampleHelper(bsxfun(@minus,Ex,MeanE));           
        end
    else
        fKernel     = @(X,Y)K{1}(X,:)*K{2}*K{1}(Y,:)';
        [N,m]       = size(K{1});        
        vMeanK      = sum(K{1}*K{2}) * K{1}'; % will be true mean - X two rows later
        dMeanK      = sum(vMeanK)/(N*N);
        vMeanK      = vMeanK/N - dMeanK;   
        vMeanK      = vMeanK';
        fTestSample = @(Kx)bsxfun(@minus,Kx',bsxfun(@plus,vMeanK,mean(Kx,2)'));
        if(exist('RSamples','var'))           
            C       = fTestSample(fKernel(1:N,RSamples)');        
            T       = C(RSamples,:);
            T       = 0.5*(T+T');
            A       = pinv(T);
            if( N*N<1e6)
                K = C*A*C';
            else
                K = [];
            end
        end
        if(0) % based on eigenvalues
            [C, A, idx] = eig_ny(K);
            N      = size(C,1);
            MeanE  = mean(C);
            C      = bsxfun(@minus,C,MeanE);
            fTestSampleHelper = @(ExC)C * A * ExC';
            fTestSample       = @(Ex)fTestSampleHelper(bsxfun(@minus,Ex,MeanE));           
            if( N*N<1e6)
                    K      = C * A * C';
            else
                    K      = []; 
            end                
        end
    end