#!/usr/bin/perl -w 
use strict;

sub read_csv_matrix
{
    open(hd0, "$_[0]") or die "Couldnt read file: $_[0]";
    my $separator = $_[1];
    my @matrix;
    my $currentrow = 0; 
    while(<hd0>)
    {
	chomp;
	my @linearray = split(/$separator/);
	foreach my $val (@linearray)
	{
	    $val =~ s/ //g;
	    push @{$matrix[$currentrow]}, $val;
	}
	$currentrow++;
    }
    return @matrix;
    close(hd0);
}

sub write_csv_matrix
{
    open(hd0, ">$_[0]") or die "Couldnt open file : $ARGV[0]";
    my $separator = $_[1];
    my $csvref    = $_[2];
    foreach my $row (@{$csvref})
    {
	for(my $i = 0; $i < scalar(@{$row}); $i++) # go through columns in origin matrix
	{
	    print hd0 @{$row}[$i]   . $separator;	#area
	}
	print hd0 "\n";
    }
    close(hd0);    
}


sub transpose_matrix
{
    my $csvref = $_[0];
    my @matrix;
    my $currentrow = 0; 
    foreach my $row (@{$csvref})
    {
	$currentrow = 0;	
	for(my $i = 0; $i < scalar(@{$row}); $i++) # go through columns in origin matrix
	{
	    push @{$matrix[$currentrow]}, @{$row}[$i];
            $currentrow++;
	}

    }
    return @matrix;
    close(hd0);
}

## MAIN ##

if($#ARGV == 1)
{
    my @csvmatrix = read_csv_matrix($ARGV[0], " ");
    my $prestring = $ARGV[0];
    $prestring =~ s/\.//g; 
    my $csvref = \@csvmatrix;
    my @csvmatrix_t = transpose_matrix($csvref);
    $csvref = \@csvmatrix_t;
    write_csv_matrix("$ARGV[1]", " ", $csvref); # will overwrite existing data
} 
else
{
    print "Specify source file in csv style" . $#ARGV;   
}
