/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * MULTICLASSMODEL_Factory.h
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * This is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * The code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MULTICLASSMODEL_Factory_H_
#define _MULTICLASSMODEL_Factory_H_
#include <armadillo>
#include <boost/serialization/vector.hpp>
#include <boost/serialization/split_free.hpp>
#include "pcvmmodel.h"
#include "pcvmtrain_interface.h"
#include "multiclassmodel_interface.h"
#include <iostream>
#include <boost/shared_ptr.hpp>
using namespace std;
using namespace arma;

enum multimodeltype
{
	one_vs_all = 0,	
	each_vs_each,
	ecoc
};

class MultiClassModelFactory
{
public:	
	MultiClassModelFactory(multimodeltype eType);
	boost::shared_ptr<IMultiClassModelInterface> GetMultiClassModel(void) {return multiclassmodel;}
	//~MultiClassModelFactory() {delete multiclassmodel;};
private:
	MultiClassModelFactory(){};
	boost::shared_ptr<IMultiClassModelInterface> multiclassmodel;
//	IMultiClassModelInterface *multiclassmodel;
};
BOOST_SERIALIZATION_SPLIT_FREE(MultiClassModelFactory)
#endif // _MULTICLASSMODEL_Factory_H_

