/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * nystroem-kernel-matrix_filtered.h
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * pcvm_cpp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * pcvm_cpp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _NYSTROEM_KERNEL_MATRIX_FILTERED_H_
#define _NYSTROEM_KERNEL_MATRIX_FILTERED_H_
#include <armadillo>
#include "nystroem-kernel-matrix.h"
using namespace arma;
class NystroemKernelMatrixFiltered: public NystroemKernelMatrix 
{
public:
	NystroemKernelMatrixFiltered();
	~NystroemKernelMatrixFiltered();
	// generate the kernel by a Nystroem kernel and vectors for filtering the data access
	bool Initialize(const uvec &X, const uvec &Y, const NystroemKernelMatrix &oKernel);
	mat  Evaluate(const uvec &X, const uvec &Y) const;
	void size(unsigned int &rows, unsigned int &cols) const;
	IKernelMatrixInterface* clone() const {
        return new NystroemKernelMatrixFiltered(*this);
    }
	mat GetParameter (int iParameter) const;
protected:

private:
	NystroemKernelMatrix m_NystroemMatrix;
	uvec m_X;
	uvec m_Y;
};

#endif // _NYSTROEM_KERNEL_MATRIX_FILTERED_H_

