#ifndef __PCVM_SERIALIZATION_HPP__
#define __PCVM_SERIALIZATION_HPP__

#ifdef __cplusplus
#include <boost/serialization/export.hpp>
#include <boost/serialization/shared_ptr.hpp>
#include "multiclassmodel_interface.h"
#include "pcvmmulticlassmodel.h"
#include "pcvmmulticlassmodel_each.h"
#include "pcvmmulticlassmodel_ecoc.h"


//============================================================================
//    Base serialization registration
//============================================================================


BOOST_CLASS_EXPORT_GUID( IMultiClassModelInterface,    "pcvm_multiclassmodel_interface"    )
BOOST_CLASS_EXPORT_GUID( pcvm_multiclass_model,    "pcvm_multiclass_model"    )
BOOST_CLASS_EXPORT_GUID( pcvm_multiclass_model_each,    "pcvm_multiclass_model_each"    )
BOOST_CLASS_EXPORT_GUID( pcvm_multiclass_model_ecoc,    "pcvm_multiclass_model_ecoc"    )


BOOST_SERIALIZATION_SHARED_PTR( IMultiClassModelInterface    )
BOOST_SERIALIZATION_SHARED_PTR( pcvm_multiclass_model    )
BOOST_SERIALIZATION_SHARED_PTR( pcvm_multiclass_model_each    )
BOOST_SERIALIZATION_SHARED_PTR( pcvm_multiclass_model_ecoc    )
//=====================
#endif    /* __cplusplus */

#endif    /* __PCVM_SERIALIZATION_HPP__ */
