/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * pcvmparameters.h
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * pcvm_cpp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * pcvm_cpp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _PCVMPARAMETERS_H_
#define _PCVMPARAMETERS_H_

class pcvm_parameters
{
public:
	pcvm_parameters(void);
	void SetIterations(unsigned int iNumberOfIterations);
	void SetMinimalThreshold(double dMinimalThreshold);
	void SetConvergenceThreshold(double dConvergenceThreshold);
	double GetMinimalThreshold(void);
	double GetConvergenceThreshold(void);
	unsigned int GetIterations(void);
protected:
	
private:
	unsigned int m_iNumberOfIterations; 
	double m_dMinimalThreshold;
	double m_dConvergenceThreshold;
};

#endif // _PCVMPARAMETERS_H_

