/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * pcvmtrain_ny.h
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * This is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * The code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _pcvmtrain_ny_H_
#define _pcvmtrain_ny_H_
#include <armadillo>
#include "pcvmparameters.h"
#include "pcvmmodel.h"
#include "pcvmtrain.h"
#include "kernel-matrix_interface.h"
using namespace std;
using namespace arma;

class pcvm_train_ny : public pcvm_train
{
public:
	pcvm_train_ny();
	~pcvm_train_ny();
	void Apply(const  IKernelMatrixInterface &oKernel, const vec &Label);
	pcvm_parameters GetParameters(void);
	void SetParameters(pcvm_parameters oParameters);
	pcvm_model GetModel(void);
protected:

private:
	pcvm_parameters m_oParameters;
	pcvm_model m_oPCVMModel;
};

#endif // _pcvmtrain_ny_H_

