/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * nystroem-kernel-matrix_filtered.cc
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * pcvm_cpp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * pcvm_cpp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "nystroem-kernel-matrix_filtered.h"

NystroemKernelMatrixFiltered::NystroemKernelMatrixFiltered():NystroemKernelMatrix()
{
}

NystroemKernelMatrixFiltered::~NystroemKernelMatrixFiltered()
{

}

bool NystroemKernelMatrixFiltered::Initialize(const uvec &X, const uvec &Y, const NystroemKernelMatrix &oKernel) 
{
	m_NystroemMatrix = oKernel;
	m_X              = X;
	m_Y              = Y;
	return true;
}

mat NystroemKernelMatrixFiltered::Evaluate(const uvec &X, const uvec &Y) const
{
	return m_NystroemMatrix.Evaluate(m_X(X),m_Y(Y));
}


void NystroemKernelMatrixFiltered::size(unsigned int &rows, unsigned int &cols) const
{
	rows = m_X.n_elem;
	cols = m_Y.n_elem;
}

mat NystroemKernelMatrixFiltered::GetParameter (int iParameter) const
{
	switch(iParameter)
	{
		case 1: 
				return m_NystroemMatrix.GetParameter(1).rows(m_X);
		case 2: 
				return m_NystroemMatrix.GetParameter(2);
	}
}
