/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * pcvmparameters.cc
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * pcvm_cpp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * pcvm_cpp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "pcvmparameters.h"
pcvm_parameters::pcvm_parameters(void)
{
	m_iNumberOfIterations = 500;
	m_dMinimalThreshold = 1e-3;
	m_dConvergenceThreshold = 1e-3;
}

void pcvm_parameters::SetIterations(unsigned int iNumberOfIterations)
{
	m_iNumberOfIterations = iNumberOfIterations;
}

void pcvm_parameters::SetMinimalThreshold(double dMinimalThreshold)
{
	m_dMinimalThreshold = dMinimalThreshold;
}

void pcvm_parameters::SetConvergenceThreshold(double dConvergenceThreshold)
{
	m_dConvergenceThreshold = dConvergenceThreshold;
}

double pcvm_parameters::GetMinimalThreshold(void)
{
	return m_dMinimalThreshold;
}

double pcvm_parameters::GetConvergenceThreshold(void)
{
	return m_dConvergenceThreshold;
}

unsigned int pcvm_parameters::GetIterations(void)
{
	return m_iNumberOfIterations;
}




